using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //requirement class

namespace demo_cs.net2005
{
    public partial class MainForm : Form
    {
        //==============================================================================================================
        //SDK interface definitions.
        [DllImport("ps2pdf", EntryPoint = "_CreatePDF@4", CallingConvention = CallingConvention.StdCall)]
        public static extern int apCreatePDF(string filename);

        [DllImport("ps2pdf", EntryPoint = "_ClosePDF@4", CallingConvention = CallingConvention.StdCall)]
        public static extern int apClosePDF(int id);

        [DllImport("ps2pdf", EntryPoint = "_SetPDFSecurity@20", CallingConvention = CallingConvention.StdCall)]
        public static extern int apSetPDFSecurity(int id, int level, int limit, string userpassword, string ownerpassword);

        [DllImport("ps2pdf", EntryPoint = "_SetPDFInfo@24", CallingConvention = CallingConvention.StdCall)]
        public static extern int apSetPDFInfo(int id, string title, string subject, string author, string keyword, string creator);

        [DllImport("ps2pdf", EntryPoint = "_AddPS@8", CallingConvention = CallingConvention.StdCall)]
        public static extern int apAddPS(int id, string filename);

        [DllImport("ps2pdf", EntryPoint = "_Convert@4", CallingConvention = CallingConvention.StdCall)]
        public static extern int apConvert(int id);

        //document permissions
        const int PERMISSION_PRINT = 1;
        const int PERMISSION_COPY = 2;
        const int PERMISSION_MODIFY = 4;
        
        //Encryption Level
        const int RC4_40BITS = 40;
        const int RC4_128BITS = 128;
        //==============================================================================================================

        public MainForm()
        {
            InitializeComponent();
        }

        //Converting several ps/eps files to one pdf file.
        private void btnDemo_Click(object sender, EventArgs e)
        {
            int id = 0;
            int iPermission = 0;
            string sUserPw = "user";
            string sOwnerPw = "owner";

            if ( (id = apCreatePDF("test_mm.pdf") ) != 0 ) {


                //setting pdf header information
                apSetPDFInfo(id, "title", "subject", "author", "keywords", "createor");

                //setting pdf security
                iPermission = PERMISSION_PRINT | PERMISSION_COPY | PERMISSION_MODIFY;
                apSetPDFSecurity(id, RC4_128BITS, iPermission, sUserPw, sOwnerPw);

                //add PS/EPS files
                apAddPS(id, "./ps_files/test1.ps");
                apAddPS(id, "./ps_files/test2.ps");
                apAddPS(id, "./ps_files/test3.ps");

                //starting convet
                apConvert(id);

                //close pdf file
                apClosePDF(id);
            }
        }
    }
}